#ifndef ASSEMBLER_CONFIG_H
#define ASSEMBLER_CONFIG_H

#include "../common/sourceFile.h"
#include "../common/string.h"
#include "../common/buffer.h"
#include "../common/platform.h"

typedef struct assembler_mapping_t {
	int offset;
	int length;
	char type;
	char access;
	int filenameLen;
	char filename[16];
} assembler_mapping_t;

typedef struct assembler_config_t {
	int codeOffset;
	int entryPoint;
	int mappingCount;
	assembler_mapping_t mappings[8];
} assembler_config_t;

int readConfig(buffer_t *buffer, assembler_config_t *config);

#endif
