#ifndef GRAPH_H
#define GRAPH_H

int Graph_fill(int color);

int Graph_pixelSet(int x, int y, int color);
int Graph_pixelGet(int x, int y);

int Graph_line(int x1, int y1, int x2, int y2, int color);
int Graph_lineH(int y, int x1, int x2, int color);
int Graph_lineV(int x, int y1, int y2, int color);

int Graph_horizontal(int y, int color);
int Graph_vertical(int x, int color);

int Graph_rect(int x, int y, int w, int h, int color);
int Graph_rectFill(int x, int y, int w, int h, int color);

int Graph_circle(int x, int y, int radius, int color);
int Graph_circleFill(int x, int y, int radius, int color);

int Graph_shiftH(int dist, int color);
int Graph_shiftV(int dist, int color);

int Graph_copy(int srcX, int srcY, int w, int h, int destX, int destY);

int Graph_sprite(int x, int y, char* sprite);

#define COLOR_WHITE 0
#define COLOR_BLACK 1
#define COLOR_XOR 2
#define COLOR_TRANSPARENT 3

typedef struct sprite_t {
	unsigned char width;
	unsigned char height;
	char format;
} sprite_t;

#define SPRITE_FORMAT_MONOCHROME 0
#define SPRITE_FORMAT_AND 1
#define SPRITE_FORMAT_OR 2
#define SPRITE_FORMAT_FULL 3

#endif
