#include "keyboard.h"
#include "platform.h"

#if defined(PC)

//BEGIN key definitions
#define KEY_0 71
#define KEY_1 72
#define KEY_2 62
#define KEY_3 52
#define KEY_4 73
#define KEY_5 63
#define KEY_6 53
#define KEY_7 74
#define KEY_8 64
#define KEY_9 54

#define KEY_EXE 31
#define KEY_EXIT 47

#define KEY_UP 28
#define KEY_RIGHT 27
#define KEY_DOWN 37
#define KEY_LEFT 38

#define KEY_F1 79
#define KEY_F2 69
#define KEY_F3 59
#define KEY_F4 49
#define KEY_F5 39
#define KEY_F6 29
//END key definitions

int Keyboard_getCode(SDL_Keycode code) {
	switch(code) {
		//keypad
		case SDLK_KP_0:
			return KEY_0;
		case SDLK_KP_1:
			return KEY_1;
		case SDLK_KP_2:
			return KEY_2;
		case SDLK_KP_3:
			return KEY_3;
		case SDLK_KP_4:
			return KEY_4;
		case SDLK_KP_5:
			return KEY_5;
		case SDLK_KP_6:
			return KEY_6;
		case SDLK_KP_7:
			return KEY_7;
		case SDLK_KP_8:
			return KEY_8;
		case SDLK_KP_9:
			return KEY_9;
		
		//Fn
		case SDLK_F1:
			return KEY_F1;
		case SDLK_F2:
			return KEY_F2;
		case SDLK_F3:
			return KEY_F3;
		case SDLK_F4:
			return KEY_F4;
		case SDLK_F5:
			return KEY_F5;
		case SDLK_F6:
			return KEY_F6;
		
		//EXE and EXIT
		case SDLK_ESCAPE:
			return KEY_EXIT;
		case SDLK_RETURN:
		case SDLK_RETURN2:
			return KEY_EXE;
		
		//arrow keys
		case SDLK_UP:
			return KEY_UP;
		case SDLK_LEFT:
			return KEY_LEFT;
		case SDLK_RIGHT:
			return KEY_RIGHT;
		case SDLK_DOWN:
			return KEY_DOWN;
	}
	return -1;
}

#endif
